#ifndef __TREF_COUNTED_BASE__
#define __TREF_COUNTED_BASE__

#include "TEvictorBase.h"

#pragma warning(disable : 4355)  // 'this' : used in base member initializer list
#pragma warning(disable : 4786)  // identifier was truncated to '255' characters in the debug information

template<class T, class T_ptr, class traits>
class TRefCountedBase;

template<class POA_Class, class T, class T_ptr, class traits> 
class TRefCounted : 
   public TEvictor<POA_Class, T, T_ptr, traits>
{
   public:

      typedef TRefCounted<POA_Class, T, T_ptr, traits> RefCountedBase;

   	virtual void AddRef()
      {
	      RefCountServantBase::_add_ref();
      }
		
      virtual void Release()
      {
	      RefCountServantBase::_remove_ref();
      }

   protected :

		TRefCounted(   
         const std::string &objectName)
         : TEvictor<POA_Class, T, T_ptr, traits>(objectName)
      {
      }
};

#endif // __TREF_COUNTED_BASE__
